//
// ErrorFeedbackAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class ErrorFeedbackAPI {

    /**
     Post ErrorFeedback
     
     - parameter errorFeedback: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func postErrorFeedback(errorFeedback: ErrorFeedback, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ErrorFeedback?, _ error: Error?) -> Void)) -> RequestTask {
        return postErrorFeedbackWithRequestBuilder(errorFeedback: errorFeedback).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Post ErrorFeedback
     - POST /ErrorFeedback
     - Post an ErrorFeedback object
     - BASIC:
       - type: http
       - name: bearerAuth
     - parameter errorFeedback: (body)  
     - returns: RequestBuilder<ErrorFeedback> 
     */
    open class func postErrorFeedbackWithRequestBuilder(errorFeedback: ErrorFeedback) -> RequestBuilder<ErrorFeedback> {
        let localVariablePath = "/ErrorFeedback"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: errorFeedback)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ErrorFeedback>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
